
namespace Smoll {
    public interface IActionable : IComparable<IActionable>{
        public int zOrder{get; set;}

        public virtual void Update(float deltaTimeSeconds) {}
        public virtual void Draw(Layer.DrawMode drawMode) {}

        int IComparable<IActionable>.CompareTo(IActionable? other)
        {
            return zOrder - other.zOrder;
        }

        public virtual bool ScheduledForRemoval() { return false; }
    }
}